io.vertx.ext.reactivestreams

## Interface ReactiveWriteStream<T>

- All Superinterfaces:
    org.reactivestreams.Publisher<T>, StreamBase, WriteStream<T>

      public interface ReactiveWriteStream<T>
      extends WriteStream<T>, org.reactivestreams.Publisher<T>

  A Vert.x write stream that also implements reactive streams publisher interface.
  Author:
    Tim Fox

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_WRITE_QUEUE_MAX_SIZE` Default write queue max size

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `ReactiveWriteStream<T>` | `close()` Close the stream
    `ReactiveWriteStream<T>` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Calls `close()`.
    `ReactiveWriteStream<T>` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the write stream.
    `ReactiveWriteStream<T>` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `ReactiveWriteStream<T>` | `write(T data)` Write some data to the stream.
    `static <T> ReactiveWriteStream<T>` | `writeStream(Vertx vertx)` Create a reactive write stream

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, writeQueueFull`

    - ### Methods inherited from interface org.reactivestreams.Publisher

      `subscribe`

- - ### Field Detail

    - #### DEFAULT_WRITE_QUEUE_MAX_SIZE

          static final int DEFAULT_WRITE_QUEUE_MAX_SIZE

      Default write queue max size
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### writeStream

          static <T> ReactiveWriteStream<T> writeStream(Vertx vertx)

      Create a reactive write stream
      Parameters:
        `vertx` - the Vert.x instance
      Returns:
        the stream

    - #### exceptionHandler

          ReactiveWriteStream<T> exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `WriteStream`
      Set an exception handler on the write stream.
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<T>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          ReactiveWriteStream<T> write(T data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WriteStream<T>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          ReactiveWriteStream<T> setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, the number of `Message` for a `MessageProducer`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<T>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          ReactiveWriteStream<T> drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pump` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.
      Specified by:
        `drainHandler` in interface `WriteStream<T>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### end

          void end()

      Calls `close()`.
      Specified by:
        `end` in interface `WriteStream<T>`

    - #### close

          ReactiveWriteStream<T> close()

      Close the stream
      Returns:
        a reference to this for a fluent API

Copyright © 2017. All rights reserved.